local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function load_particle(material, px, py)
	local particle_id = EntityCreateNew()
	EntitySetTransform(particle_id, px, py)
	if px > 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px > 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	end
	
	EntityAddComponent2(particle_id, "LifetimeComponent", {
		lifetime=1,
	} )
end

local did_hit_left = Raytrace(x - 1, y, x - Random(5,20), y)
local did_hit_right = Raytrace(x + 1, y, x + Random(5,20), y)
local did_hit_bottom = Raytrace(x, y + 1, x, y + Random(5,20))

if did_hit_left and did_hit_right then

	load_particle( "particle_life_dragonfly_left2", x, y +1 )
	
elseif not did_hit_left and did_hit_bottom then

	load_particle( "particle_life_dragonfly_left2", x - 1, y - 1 )
	
elseif not did_hit_left and not did_hit_bottom then

	load_particle( "particle_life_dragonfly_left2", x - 1, y + 1 )
	
elseif did_hit_left then

	load_particle( "particle_life_dragonfly_right2", x, y )
	
else

	load_particle( "particle_life_dragonfly_left2", x, y )

end

EntityKill( entity_id )
