local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function load_particle(material, px, py)
	local particle_id = EntityCreateNew()
	EntitySetTransform(particle_id, px, py)
	if px > 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
		
	elseif px < 0 and py < 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
	elseif px < 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
	elseif px > 0 and py > 0 then 
	
		local particle_comp = EntityAddComponent2(particle_id, "ParticleEmitterComponent", {
			emitted_material_name=material,
			x_pos_offset_min=1,
			x_pos_offset_max=1,
			y_pos_offset_min=1,
			y_pos_offset_max=1,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			count_min=1,
			count_max=1,
			emission_interval_min_frames=0,
			emission_interval_max_frames=0,
			image_animation_file="mods/particle_life/files/image_emitters/material_particle.png",
			image_animation_loop=true,
			emit_cosmetic_particles=false,
			create_real_particles=true
		} )
		ComponentSetValue2(particle_comp, "offset", 0, 0)
	end
	EntityAddComponent2(particle_id, "LifetimeComponent", {
		lifetime=1,
	} )
end


local did_hit_bottom_left, hit_x, hit_y = Raytrace(x - 1, y + 1 , x - 1, y + 1)

local in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform(x - 1, y + 1 , x - 1, y + 1)
local in_solid, hit_x, hit_y = RaytracePlatforms(x - 1, y + 1 , x - 1, y + 1)

local did_hit_left2 = RaytracePlatforms(x - 1, y , x - 2, y)
local did_hit_right2 = RaytracePlatforms(x + 1, y, x + 2, y)
local did_hit_left_up2 = RaytracePlatforms(x - 1, y - 1 , x - 2, y -2)
local did_hit_right_up2 = RaytracePlatforms(x + 1, y - 1 , x + 2, y -2)
local did_hit_bottom2 = RaytracePlatforms(x, y + 1, x, y + 2)

local did_hit_left_water = RaytraceSurfacesAndLiquiform(x - 1, y , x - 2, y)
local did_hit_right_water = RaytraceSurfacesAndLiquiform(x + 1, y, x + 2, y)
local did_hit_left_up_water = RaytraceSurfacesAndLiquiform(x - 1, y - 1 , x - 2, y -2)
local did_hit_right_up_water = RaytraceSurfacesAndLiquiform(x + 1, y - 1 , x + 2, y -2)
local did_hit_bottom_water = RaytraceSurfacesAndLiquiform(x, y + 1, x, y + 2)

if ( not (not did_hit_left2 and did_hit_left_water ) ) and
( not (not did_hit_right2 and did_hit_right_water ) ) and
( not (not did_hit_left_up2 and did_hit_left_up_water ) ) and
( not (not did_hit_right_up2 and did_hit_right_up_water ) ) and
( not (not did_hit_bottom2 and did_hit_bottom_water ) ) then

	if not in_water and not in_solid then
		if not did_hit_bottom_left then

			local value = Random( 1, 1 )
			if Random( 1, 6 ) == 1 then
				load_particle( "particle_life_firefly3_ac", x - value, y + value )
			else
				load_particle( "particle_life_firefly2_ac", x - value, y + value )
			end
		end
	else

		load_particle( "particle_life_firefly3_ac", x, y )
	end
else
	local found, nx, ny, apd = GetSurfaceNormal(x, y, 10, 20)
	if found then
	  nx = nx * (math.abs(apd) + 2)
	  ny = ny * (math.abs(apd) + 2)
	else
	  nx = 0
	  ny = 0
	end
	load_particle( "particle_life_firefly_idle", x - nx, y - ny )
end

GameCreateSpriteForXFrames( "mods/particle_life/files/image_emitters/firefly_glow2.png",x, y, true, 0, 0, 2, true )
EntityKill( entity_id )
