function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local state = get_state()
state.offset_x = state.offset_x or 0
state.offset_y = state.offset_y or 0

x = x + state.offset_x
y = y + state.offset_y

local in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x, y, x, y )
local in_solid, hit_x2, hit_y2 = RaytracePlatforms( x, y, x, y )
local in_particle, hit_x3, hit_y3 = Raytrace( x, y, x, y )

setting_cache = setting_cache or {}
local function get_setting(name)
    setting_cache[name] = setting_cache[name] or ModSettingGet(name)
    return setting_cache[name]
end

local nanobots = get_setting("particle_life.nanobots")

if ( not in_particle ) and ( nanobots > 0 ) then
  SetRandomSeed( GameGetFrameNum(), x + y )
  local nanobots_random_number = Random(nanobots,90)

  if ( nanobots_random_number == nanobots ) then
	local desired_x = x + Random(-16, 16)
	local desired_y = y + Random(-16, 16)
	EntityLoad("mods/particle_life/files/nanobots_air_checker.xml", desired_x, desired_y)
  end
end

if state.offset_y + 16 < 511 then
  if state.offset_x + 16 < 511 then
	state.offset_x = state.offset_x + 16
  else
	state.offset_x = 0
	state.offset_y = state.offset_y + 16
  end
else
  EntityKill(entity_id)
end