--Addition of Materials
function replace_value(path, input, output, print_bool)
	local content = ModTextFileGetContent(path)
	content = content:gsub(input, output)
	ModTextFileSetContent(path, content)
	if print_bool then
		print(content)
	end
end

ModMaterialsFileAdd("mods/particle_life/files/materials/materials.xml")

--Increasing material Limit
ModMagicNumbersFileAdd( "mods/particle_life/files/materials/increase_material_limit.xml" ) 

local nxml = dofile_once("mods/particle_life/lib/nxml.lua")

-- local content_materials = ModTextFileGetContent("mods/particle_life/files/materials/materials.xml")
-- local xml_orig = nxml.parse(content_materials)

-- local new_material_count = 0

-- for element in xml_orig:each_child() do
	-- new_material_count = new_material_count + 1
-- end

-- local original_maximum = MagicNumbersGetValue( "CELLFACTORY_CELLDATA_MAX_COUNT" )

-- if original_maximum == 1024 then
-- replace_value("data/magic_numbers.xml", [[%<MagicNumbers]], ([[<MagicNumbers 
  -- CELLFACTORY_CELLDATA_MAX_COUNT="%s"]]):format(original_maximum + new_material_count), true)

function escape_pattern(text)
    return text:gsub("([^%w])", "%%%1")
end

--Shader Heat Shimmering Effect
if ModSettingGet("particle_life.heat") then
replace_value("data/shaders/post_final.frag", 
[[if %(ENABLE_REFRACTION%)%s+{[^}]*}]],
[[if (ENABLE_REFRACTION)
    {
        vec4 noise_perlin_x = texture2D( tex_perlin_noise, world_pos * 0.0004 + vec2(0.0,noise_time * 0.005) );
        vec4 noise_perlin_y = texture2D( tex_perlin_noise, world_pos * 0.0004 + vec2(0.0,(noise_time+10.0) * 0.005) );
        vec3 heat = texture2D(tex_glow, vec2(tex_coord_glow.x, tex_coord_glow.y+0.1)).rgb;
        float heat_mask = (heat.r / (((heat.g+heat.b)*10.0)+1.0)) * 5.0;

        vec2 liquid_distortion_offset = vec2(
            liquid_mask * sin((noise_perlin_x.g * 40.0) + (time * 6.0)) * 0.0015,
            liquid_mask * sin((noise_perlin_y.g * 40.0) + (time * 6.0)) * 0.0015 * (SCREEN_W/SCREEN_H)
            ) / camera_inv_zoom_ratio;
        vec2 heat_distortion_offset = vec2(
            heat_mask * sin((noise_perlin_x.g * 120.0) + (time * 12.0)) * 0.0015,
            heat_mask * sin((noise_perlin_y.g * 120.0) + (time * 12.0)) * 0.0015 * (SCREEN_W/SCREEN_H)
            ) / camera_inv_zoom_ratio;
            
        // distort the texture coordinate if the pixel we would sample is liquid
        vec4 extra_data_at_liquid_offset = texture2D( tex_glow_unfiltered, tex_coord_glow + vec2( liquid_distortion_offset.x, -liquid_distortion_offset.y ) );
        liquid_distortion_offset *= step( SHADING_LIQUID_BITS_ALPHA, extra_data_at_liquid_offset.a );

        tex_coord = tex_coord + liquid_distortion_offset + heat_distortion_offset;
        tex_coord_y_inverted += vec2( liquid_distortion_offset.x, -liquid_distortion_offset.y );
        tex_coord_glow += vec2( liquid_distortion_offset.x, -liquid_distortion_offset.y );
    }]]
)
end

--adding particle life forms on enemies
if ModSettingGet("particle_life.enemy_particle") then
	replace_value("data/entities/base_humanoid.xml", 
	[[%<ItemChestComponent]], 
	[[<LuaComponent
		execute_every_n_frame="-1"
		execute_on_added="1"
		script_source_file="mods/particle_life/files/particle_emitter_attacher.lua"
		remove_after_executed="1" >
	</LuaComponent>

	<ItemChestComponent]]
	)
end

--snow flakes reaction
if ModSettingGet("particle_life.snowflakes") then
	-- ModMaterialsFileAdd("mods/particle_life/files/materials/snowflakes_reaction.xml")

	local content = ModTextFileGetContent("data/materials.xml")
	local xml = nxml.parse(content)
	for element in xml:each_child() do
		if element.attr.name == "snow_static" then
			element:add_child(nxml.parse([[
			<ParticleEffect	
			vel.y="0"
			vel_random.min_x="0"
			vel_random.max_x="0"
			vel_random.min_y="0"
			vel_random.max_y="5"
			lifetime.min="1"
			lifetime.max="10"
			gravity.y="0.4"
			render_on_grid="0"
			airflow_force="20"
			airflow_scale="0.016"
			friction="0.0001"
			probability="0.1"
			count.min="0"
			count.max="1"
			>
			</ParticleEffect>
			]]))
		end
	end
	ModTextFileSetContent("data/materials.xml", tostring(xml))
end

--Desert wind simulation
if ModSettingGet("particle_life.sand") then
	-- ModMaterialsFileAdd("mods/particle_life/files/materials/snowflakes_reaction.xml")
	
	local nxml = dofile_once("mods/particle_life/lib/nxml.lua")
	local content = ModTextFileGetContent("data/materials.xml")
	local xml = nxml.parse(content)
	for element in xml:each_child() do
		if element.attr.name == "sand_surface" then
			element:add_child(nxml.parse([[
			<ParticleEffect	
			vel.y="0"
			vel_random.min_x="0"
			vel_random.max_x="0"
			vel_random.min_y="0"
			vel_random.max_y="5"
			lifetime.min="1"
			lifetime.max="10"
			gravity.y="0.4"
			render_on_grid="0"
			airflow_force="20"
			airflow_scale="0.016"
			friction="0.0001"
			probability="0.1"
			count.min="0"
			count.max="1"
			>
			</ParticleEffect>
			]]))
		end
	end
	ModTextFileSetContent("data/materials.xml", tostring(xml))
end

--snow flakes reaction
if ModSettingGet("particle_life.icicles") then
	ModMaterialsFileAdd("mods/particle_life/files/materials/icicles_reaction.xml")
end

--lava reaction
if ModSettingGet("particle_life.lava") then
	ModMaterialsFileAdd("mods/particle_life/files/materials/lava_reaction.xml")
end

--particle bugs and creatures
replace_value("data/scripts/biomes/coalmine.lua", 
[[-- this is a special function tweaked for spawning things in coalmine]], 
[[-- this is a special function tweaked for spawning things in coalmine

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/coalmine_alt.lua", 
[[-- this is a special function tweaked for spawning things in coalmine]], 
[[-- this is a special function tweaked for spawning things in coalmine

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/excavationsite.lua", 
[[-- this is a special function tweaked for spawning things in coal mines]], 
[[-- this is a special function tweaked for spawning things in coal mines

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/fungiforest.lua", 
[[function init%(x%, y%, w%, h%)]], 
[[function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_fungus_spawner_spawner.xml", x + 256, y + 256)]]
)

replace_value("data/scripts/biomes/fungicave.lua", 
[[function init%(x%, y%, w%, h%)]], 
[[function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_fungus_spawner_spawner.xml", x + 256, y + 256)]]
)

replace_value("data/scripts/biomes/rainforest.lua", 
[[function init%(x%, y%, w%, h%)]], 
[[function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x, y)]]
)

replace_value("data/scripts/biomes/hills.lua", 
[[function init%(x%, y%, w%, h%)]], 
[[function init(x, y, w, h)
	if y > -520 and ( not ( BiomeMapGetName( x, y ) == "$biome_winter" ) ) then
		EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
	end]]
)

replace_value("data/scripts/biomes/desert.lua", 
[[function init%(x%, y%, w%, h%)]], 
[[function init(x, y, w, h)
	if y > 0 then
		EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
	end]]
)

replace_value("data/scripts/biomes/mountain_lake.lua", 
[[function init%( x%, y%, w%, h %)]], 
[[function init(x, y, w, h)
	if y > -520 then
		EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
	end]]
)

replace_value("data/scripts/biomes/lake_statue.lua", 
[[function init%( x%, y%, w%, h %)]], 
[[function init(x, y, w, h)
	if y > -520 then
		EntityLoad("mods/particle_life/files/material_bug_spawner_spawner.xml", x + 256, y + 256)
	end]]
)

replace_value("data/scripts/biomes/wandcave.lua", 
[[-- this is a special function tweaked for spawning things in coal mines]], 
[[-- this is a special function tweaked for spawning things in coal mines

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_souls_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/crypt.lua", 
[[function init%( x%, y %) end]], 
[[function init( x, y )
	EntityLoad("mods/particle_life/files/material_souls_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/pyramid.lua", 
[[function init%( x%, y%, w%, h %)]], 
[[function init( x, y, w, h )
	EntityLoad("mods/particle_life/files/material_souls_spawner_spawner.xml", x + 256, y + 256)]]
)

replace_value("data/scripts/biomes/vault.lua", 
[[-- actual functions that get called from the wang generator]], 
[[-- actual functions that get called from the wang generator

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_nanobots_spawner_spawner.xml", x + 256, y + 256)
end]]
)

replace_value("data/scripts/biomes/vault_frozen.lua", 
[[-- actual functions that get called from the wang generator]], 
[[-- actual functions that get called from the wang generator

RegisterSpawnFunction(0xffffeedd, "init")

function init(x, y, w, h)
	EntityLoad("mods/particle_life/files/material_nanobots_spawner_spawner.xml", x + 256, y + 256)
end]]
)

-- replace_value("data/scripts/biomes/snowcave.lua", 
-- [[function init%(x%, y%, w%, h%)]], 
-- [[function init(x, y, w, h)
	-- EntityLoad("mods/particle_life/files/material_bug_spawner.xml", x, y)]]
-- )

--remove materials from shiftinf pool

replace_value("data/scripts/magic/fungal_shift.lua", 
[[local held_material %= get_held_item_material%( entity %)]], 
[[local held_material = get_held_item_material( entity )
local held_material_name = CellFactory_GetName(held_material)
if held_material_name == "particle_life_dragonfly_right" or
held_material_name == "particle_life_dragonfly_right2" or
held_material_name == "particle_life_dragonfly_left" or
held_material_name == "particle_life_dragonfly_left2" or
held_material_name == "particle_life_spider_spawner" or
held_material_name == "particle_life_spider" or
held_material_name == "particle_life_spider_web" or
held_material_name == "particle_life_earth_worm" or
held_material_name == "particle_life_snake_seed" or
held_material_name == "particle_life_snake" or
held_material_name == "particle_life_snake_tail" or
held_material_name == "particle_life_snake_flower_red" or
held_material_name == "particle_life_snake_flower_red2" or
held_material_name == "particle_life_snake_flower_red3" or
held_material_name == "particle_life_snake_flower_yellow" or
held_material_name == "particle_life_snake_flower_yellow2" or
held_material_name == "particle_life_snake_flower_yellow3" or
held_material_name == "particle_life_snake_flower_orange" or
held_material_name == "particle_life_snake_flower_orange2" or
held_material_name == "particle_life_snake_flower_orange3" or
held_material_name == "particle_life_snake_flower_blue" or
held_material_name == "particle_life_snake_flower_blue2" or
held_material_name == "particle_life_snake_flower_blue3" or
held_material_name == "particle_life_water_bug" or
held_material_name == "particle_life_water_swamp_bug" or
held_material_name == "particle_life_mosquito" or
held_material_name == "particle_life_mosquito_wing" or
held_material_name == "particle_life_mosquito_temp" or
held_material_name == "particle_life_mosquito_wing_temp" or
held_material_name == "particle_life_flea_temp" or
held_material_name == "particle_life_ant" or
held_material_name == "particle_life_flea" then
	held_material = 0
end
]]
)

--Removing particle life from twitch extended fungal shifts
if ModIsEnabled("twitch_extended") then

	-- ModLuaFileAppend( "mods/twitch_extended/files/scripts/config/config_list.lua", "data/scripts/twitch_extended_append.lua" )
	-- ModLuaFileAppend( "mods/twitch_extended/files/scripts/utils/utilities.lua", "data/scripts/twitch_extended_append.lua" )

	--this isn't doing anything: (Not working)
	replace_value("mods/twitch_extended/files/scripts/config/config_list.lua", 
		[[shift_material_blacklist_inputs %= %{]], 
		[[shift_material_blacklist_inputs = {
			particle_life_dragonfly_right = true,
			particle_life_dragonfly_right2 = true,
			particle_life_dragonfly_left = true,
			particle_life_dragonfly_left2 = true,
			particle_life_spider_spawner = true,
			particle_life_spider = true,
			particle_life_spider_web = true,
			particle_life_earth_worm = true,
			particle_life_earth_worm_tail = true,
			particle_life_snake_seed = true,
			particle_life_snake = true,
			particle_life_snake_tail = true,
			particle_life_snake_flower_red = true,
			particle_life_snake_flower_red2 = true,
			particle_life_snake_flower_red3 = true,
			particle_life_snake_flower_yellow = true,
			particle_life_snake_flower_yellow2 = true,
			particle_life_snake_flower_yellow3 = true,
			particle_life_snake_flower_orange = true,
			particle_life_snake_flower_orange2 = true,
			particle_life_snake_flower_orange3 = true,
			particle_life_snake_flower_blue = true,
			particle_life_snake_flower_blue2 = true,
			particle_life_snake_flower_blue3 = true,
			particle_life_water_bug = true,
			particle_life_water_swamp_bug = true,
			particle_life_mosquito = true,
			particle_life_mosquito_wing = true,
			particle_life_mosquito_temp = true,
			particle_life_mosquito_wing_temp = true,
			particle_life_flea_temp = true,
			particle_life_ant = true,
			particle_life_flea = true,
			
			particle_life_soul = true,
			particle_life_soul_tail = true,
			particle_life_snowflake_base = true,
			particle_life_snowflake = true,
			particle_life_snowflake2 = true,
			particle_life_snowflake2_ac = true,
			particle_life_snowflake3 = true,
			particle_life_snowflake3_ac = true,
			particle_life_snowflake4 = true,
			particle_life_snowflake4_ac = true,
			particle_life_snowflake5 = true,
			particle_life_snowflake5_ac = true,
			particle_life_snowflake6 = true,
			particle_life_snowflake6_ac = true,
			particle_life_snowflake7 = true,
			particle_life_snowflake7_ac = true,
			particle_life_snowflake8 = true,
			particle_life_snowflake8_ac = true,
			particle_life_snowflake_idle = true,
			
			particle_life_mycelium_seed = true,
			particle_life_mycelium = true,
			particle_life_mycelium_ceiling_seed = true,
			particle_life_mycelium_ceiling = true,
			particle_life_mycelium_spore = true,
			particle_life_mycelium_spore2 = true,
			particle_life_mycelium_spore3 = true,
			particle_life_mycelium_spore4 = true,
			particle_life_mycelium_spore5 = true,
			
			particle_life_firefly = true,
			particle_life_firefly2 = true,
			particle_life_firefly2_ac = true,
			particle_life_firefly3 = true,
			particle_life_firefly3_ac = true,
			particle_life_firefly4 = true,
			particle_life_firefly4_ac = true,
			particle_life_firefly5 = true,
			particle_life_firefly5_ac = true,
			particle_life_firefly6 = true,
			particle_life_firefly6_ac = true,
			particle_life_firefly7 = true,
			particle_life_firefly7_ac = true,
			particle_life_firefly8 = true,
			particle_life_firefly8_ac = true,
			particle_life_firefly_idle = true,
			
			particle_life_icicle_grower = true,
			particle_life_icicle_go_through = true
		]]
	)
	
	replace_value("mods/twitch_extended/files/scripts/config/config_list.lua", 
		[[shift_material_blacklist_outputs  %= %{]], 
		[[shift_material_blacklist_outputs  = {
			particle_life_dragonfly_right = true,
			particle_life_dragonfly_right2 = true,
			particle_life_dragonfly_left = true,
			particle_life_dragonfly_left2 = true,
			particle_life_spider_spawner = true,
			particle_life_spider = true,
			particle_life_spider_web = true,
			particle_life_earth_worm = true,
			particle_life_earth_worm_tail = true,
			particle_life_snake_seed = true,
			particle_life_snake = true,
			particle_life_snake_tail = true,
			particle_life_snake_flower_red = true,
			particle_life_snake_flower_red2 = true,
			particle_life_snake_flower_red3 = true,
			particle_life_snake_flower_yellow = true,
			particle_life_snake_flower_yellow2 = true,
			particle_life_snake_flower_yellow3 = true,
			particle_life_snake_flower_orange = true,
			particle_life_snake_flower_orange2 = true,
			particle_life_snake_flower_orange3 = true,
			particle_life_snake_flower_blue = true,
			particle_life_snake_flower_blue2 = true,
			particle_life_snake_flower_blue3 = true,
			particle_life_water_bug = true,
			particle_life_water_swamp_bug = true,
			particle_life_mosquito = true,
			particle_life_mosquito_wing = true,
			particle_life_mosquito_temp = true,
			particle_life_mosquito_wing_temp = true,
			particle_life_flea_temp = true,
			particle_life_ant = true,
			particle_life_flea = true,
			
			particle_life_soul = true,
			particle_life_soul_tail = true,
			particle_life_snowflake_base = true,
			particle_life_snowflake = true,
			particle_life_snowflake2 = true,
			particle_life_snowflake2_ac = true,
			particle_life_snowflake3 = true,
			particle_life_snowflake3_ac = true,
			particle_life_snowflake4 = true,
			particle_life_snowflake4_ac = true,
			particle_life_snowflake5 = true,
			particle_life_snowflake5_ac = true,
			particle_life_snowflake6 = true,
			particle_life_snowflake6_ac = true,
			particle_life_snowflake7 = true,
			particle_life_snowflake7_ac = true,
			particle_life_snowflake8 = true,
			particle_life_snowflake8_ac = true,
			
			particle_life_mycelium_seed = true,
			particle_life_mycelium = true,
			particle_life_mycelium_ceiling_seed = true,
			particle_life_mycelium_ceiling = true,
			particle_life_mycelium_spore = true,
			particle_life_mycelium_spore2 = true,
			particle_life_mycelium_spore3 = true,
			particle_life_mycelium_spore4 = true,
			particle_life_mycelium_spore5 = true,
			
			particle_life_firefly = true,
			particle_life_firefly2 = true,
			particle_life_firefly2_ac = true,
			particle_life_firefly3 = true,
			particle_life_firefly3_ac = true,
			particle_life_firefly4 = true,
			particle_life_firefly4_ac = true,
			particle_life_firefly5 = true,
			particle_life_firefly5_ac = true,
			particle_life_firefly6 = true,
			particle_life_firefly6_ac = true,
			particle_life_firefly7 = true,
			particle_life_firefly7_ac = true,
			particle_life_firefly8 = true,
			particle_life_firefly8_ac = true,
			particle_life_firefly_idle = true,
			
			particle_life_icicle_grower = true,
			particle_life_icicle_go_through = true
		]]
	)
	
	-- print(ModTextFileGetContent("mods/twitch_extended/files/scripts/config/config_list.lua"))

end