dofile("data/scripts/lib/mod_settings.lua")

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	print( tostring(new_value) )
end

local mod_id = "particle_life"
mod_settings_version = 1
mod_settings = 
{
	{
	  id = "ants",
	  ui_name = "Ants",
	  ui_description = "Spawn probability of ants",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "water_bugs",
	  ui_name = "Water Bugs",
	  ui_description = "Spawn probability of water bugs",
	  value_default = 1,
	  value_min = 0,
	  value_max = 4,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "earth_worms",
	  ui_name = "Earth Worms",
	  ui_description = "Spawn probability of earth worms",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "termites",
	  ui_name = "Termites",
	  ui_description = "Spawn probability of termites",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "spiders",
	  ui_name = "Spiders",
	  ui_description = "Spawn probability of spiders",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "flies",
	  ui_name = "Flies",
	  ui_description = "Spawn probability of flies",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "fleas",
	  ui_name = "Fleas",
	  ui_description = "Spawn probability of fleas",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "dragonflies",
	  ui_name = "Dragonflies",
	  ui_description = "Spawn probability of dragonflies",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "fireflies",
	  ui_name = "Fireflies",
	  ui_description = "Spawn probability of Fireflies",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "snakes",
	  ui_name = "Plants",
	  ui_description = "Spawn probability of plants",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "mycelium",
	  ui_name = "Mycelium",
	  ui_description = "Spawn probability of mycelium (only in fungal and overgrown caverns)",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "nanobots",
	  ui_name = "Nano-bots",
	  ui_description = "Spawn probability of Nano-bots (These only appear in the Vault and Frozen Vault)",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "souls",
	  ui_name = "Souls",
	  ui_description = "Spawn probability of Souls (These only appear in magical temple)",
	  value_default = 1,
	  value_min = 0,
	  value_max = 5,
	  value_display_multiplier = 25,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
		id = "enemy_particle",
		ui_name = "Enemy Particles",
		ui_description = "Toggle particles such as fleas and flies shed by enemies",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "heat",
		ui_name = "Heat Shimmering Effect",
		ui_description = "Toggle the heat effect produced in the shader for lava and fire",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "sand",
		ui_name = "Desert Wind (sand storm)",
		ui_description = "Toggle Windy dust particles which appear in the desert",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "snowflakes",
		ui_name = "Snow Flakes (windy snow simulation)",
		ui_description = "Toggle Windy snowflake particles which appear in cold areas",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "icicles",
		ui_name = "Particle Icicles",
		ui_description = "Toggle icicles which grow in cold areas (they don't damage you)",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "lava",
		ui_name = "Bubbling Lava",
		ui_description = "Toggle Lava Bubbling (can interfere slightly with gameplay)",
		value_default = false,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end